2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]]
22 TMP="$GIT_DIR/.git-stash.$$"
23 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
24 trap 'rm -f "$TMP-"* "$TMPindex"' 0
28 if git config --get-colorbool color.interactive; then
29 help_color="$(git config --get-color color.interactive.help 'red bold')"
30 reset_color="$(git config --get-color '' reset)"
37 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
38 git diff-files --quiet --ignore-submodules &&
39 (test -z "$untracked" || test -z "$(untracked_files)")
43 excl_opt=--exclude-standard
44 test "$untracked" = "all" && excl_opt=
45 git ls-files -o -z $excl_opt
51 die "$(gettext "git stash clear with parameters is unimplemented")"
53 if current=$(git rev-parse --verify --quiet $ref_stash)
55 git update-ref -d $ref_stash $current
63 git update-index -q --refresh
69 # state of the base commit
70 if b_commit=$(git rev-parse --verify HEAD)
72 head=$(git rev-list --oneline -n 1 HEAD --)
74 die "$(gettext "You do not have the initial commit yet")"
77 if branch=$(git symbolic-ref -q HEAD)
79 branch=${branch#refs/heads/}
83 msg=$(printf '%s: %s' "$branch" "$head")
86 i_tree=$(git write-tree) &&
87 i_commit=$(printf 'index on %s\n' "$msg" |
88 git commit-tree $i_tree -p $b_commit) ||
89 die "$(gettext "Cannot save the current index state")"
91 if test -n "$untracked"
93 # Untracked files are stored by themselves in a parentless commit, for
94 # ease of unpacking later.
97 GIT_INDEX_FILE="$TMPindex" &&
98 export GIT_INDEX_FILE &&
100 git update-index -z --add --remove --stdin &&
101 u_tree=$(git write-tree) &&
102 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
104 ) ) || die "Cannot save the untracked files"
106 untracked_commit_option="-p $u_commit";
108 untracked_commit_option=
111 if test -z "$patch_mode"
114 # state of the working tree
116 git read-tree --index-output="$TMPindex" -m $i_tree &&
117 GIT_INDEX_FILE="$TMPindex" &&
118 export GIT_INDEX_FILE &&
119 git diff --name-only -z HEAD -- >"$TMP-stagenames" &&
120 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
124 die "$(gettext "Cannot save the current worktree state")"
128 rm -f "$TMP-index" &&
129 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
131 # find out what the user wants
132 GIT_INDEX_FILE="$TMP-index" \
133 git add--interactive --patch=stash -- &&
135 # state of the working tree
136 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
137 die "$(gettext "Cannot save the current worktree state")"
139 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
140 test -s "$TMP-patch" ||
141 die "$(gettext "No changes selected")"
143 rm -f "$TMP-index" ||
144 die "$(gettext "Cannot remove temporary index (can't happen)")"
149 if test -z "$stash_msg"
151 stash_msg=$(printf 'WIP on %s' "$msg")
153 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
155 w_commit=$(printf '%s\n' "$stash_msg" |
156 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
157 die "$(gettext "Cannot record working tree state")"
178 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
181 if test -z "$stash_msg"
183 stash_msg="Created via \"git stash store\"."
186 # Make sure the reflog for stash is kept.
187 : >>"$(git rev-parse --git-path logs/$ref_stash)"
188 git update-ref -m "$stash_msg" $ref_stash $w_commit
190 test $ret != 0 && test -z $quiet &&
191 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
210 # only default to keep if we don't already have an override
211 test -z "$keep_index" && keep_index=t
216 -u|--include-untracked)
231 # TRANSLATORS: $option is an invalid option, like
232 # `--blah-blah'. The 7 spaces at the beginning of the
233 # second line correspond to "error: ". So you should line
234 # up the second line with however many characters the
235 # translation of "error: " takes in your language. E.g. in
238 # $ git stash save --blah-blah 2>&1 | head -n 2
239 # error: unknown option for 'stash save': --blah-blah
240 # To provide a message, use git stash save -- '--blah-blah'
241 eval_gettextln "error: unknown option for 'stash save': \$option
242 To provide a message, use git stash save -- '\$option'"
252 if test -n "$patch_mode" && test -n "$untracked"
254 die "Can't use --patch and --include-untracked or --all at the same time"
259 git update-index -q --refresh
262 say "$(gettext "No local changes to save")"
265 test -f "$(git rev-parse --git-path logs/$ref_stash)" ||
266 clear_stash || die "$(gettext "Cannot initialize stash")"
268 create_stash "$stash_msg" $untracked
269 store_stash -m "$stash_msg" -q $w_commit ||
270 die "$(gettext "Cannot save the current status")"
271 say Saved working directory and index state "$stash_msg"
273 if test -z "$patch_mode"
275 git reset --hard ${GIT_QUIET:+-q}
276 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
277 if test -n "$untracked"
279 git clean --force --quiet -d $CLEAN_X_OPTION
282 if test "$keep_index" = "t" && test -n $i_tree
284 git read-tree --reset -u $i_tree
287 git apply -R < "$TMP-patch" ||
288 die "$(gettext "Cannot remove worktree changes")"
290 if test "$keep_index" != "t"
298 git rev-parse --verify --quiet $ref_stash >/dev/null
302 have_stash || return 0
303 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
307 ALLOW_UNKNOWN_FLAGS=t
308 assert_stash_like "$@"
310 git diff ${FLAGS:---stat} $b_commit $w_commit
319 # Parses the remaining options looking for flags and
320 # at most one revision defaulting to ${ref_stash}@{0}
323 # Derives related tree and commit objects from the
324 # revision, if one is found.
326 # stash records the work tree, and is a merge between the
327 # base commit (first parent) and the index tree (second parent).
329 # REV is set to the symbolic version of the specified stash-like commit
330 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
331 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
332 # s is set to the SHA1 of the stash commit
333 # w_commit is set to the commit containing the working tree
334 # b_commit is set to the base commit
335 # i_commit is set to the commit containing the index tree
336 # u_commit is set to the commit containing the untracked files tree
337 # w_tree is set to the working tree
338 # b_tree is set to the base tree
339 # i_tree is set to the index tree
340 # u_tree is set to the untracked files tree
342 # GIT_QUIET is set to t if -q is specified
343 # INDEX_OPTION is set to --index if --index is specified.
344 # FLAGS is set to the remaining flags (if allowed)
347 # * too many revisions specified
348 # * no revision is specified and there is no stash stack
349 # * a revision is specified which cannot be resolve to a SHA1
350 # * a non-existent stash reference is specified
351 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
354 parse_flags_and_rev()
356 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
372 REV=$(git rev-parse --no-flags --symbolic --sq "$@") || exit 1
388 test "$ALLOW_UNKNOWN_FLAGS" = t ||
389 die "$(eval_gettext "unknown option: \$opt")"
390 FLAGS="${FLAGS}${FLAGS:+ }$opt"
399 have_stash || die "$(gettext "No stash found.")"
400 set -- ${ref_stash}@{0}
406 die "$(eval_gettext "Too many revisions specified: \$REV")"
410 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
412 die "$(eval_gettext "\$reference is not a valid reference")"
415 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
416 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
424 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
427 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
428 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
433 parse_flags_and_rev "$@"
434 test -n "$IS_STASH_LIKE"
437 assert_stash_like() {
438 is_stash_like "$@" || {
440 die "$(eval_gettext "'\$args' is not a stash-like commit")"
445 is_stash_like "$@" && test -n "$IS_STASH_REF"
449 is_stash_ref "$@" || {
451 die "$(eval_gettext "'\$args' is not a stash reference")"
457 assert_stash_like "$@"
459 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
460 git diff-index --cached --quiet --ignore-submodules HEAD -- ||
461 die "$(gettext "Cannot apply stash: Your index contains uncommitted changes.")"
463 # current index state
464 c_tree=$(git write-tree) ||
465 die "$(gettext "Cannot apply a stash in the middle of a merge")"
467 unstashed_index_tree=
468 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
469 test "$c_tree" != "$i_tree"
471 git diff-tree --binary $s^2^..$s^2 | git apply --cached
473 die "$(gettext "Conflicts in index. Try without --index.")"
474 unstashed_index_tree=$(git write-tree) ||
475 die "$(gettext "Could not save index tree")"
481 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
482 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
484 die 'Could not restore untracked files from stash'
488 GITHEAD_$w_tree='Stashed changes' &&
489 GITHEAD_$c_tree='Updated upstream' &&
490 GITHEAD_$b_tree='Version stash was based on' &&
491 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
494 if test -n "$GIT_QUIET"
496 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
498 if git merge-recursive $b_tree -- $c_tree $w_tree
501 if test -n "$unstashed_index_tree"
503 git read-tree "$unstashed_index_tree"
506 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
507 git read-tree --reset $c_tree &&
508 git update-index --add --stdin <"$a" ||
509 die "$(gettext "Cannot unstage modified files")"
513 if test -n "$GIT_QUIET"
515 squelch='>/dev/null 2>&1'
517 (cd "$START_DIR" && eval "git status $squelch") || :
519 # Merge conflict; keep the exit status from merge-recursive
522 if test -n "$INDEX_OPTION"
524 gettextln "Index was not unstashed." >&2
531 assert_stash_ref "$@"
538 say "The stash is kept in case you need it again."
544 assert_stash_ref "$@"
546 git reflog delete --updateref --rewrite "${REV}" &&
547 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
548 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
550 # clear_stash if we just dropped the last stash entry
551 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
556 test -n "$1" || die "$(gettext "No branch name specified")"
561 assert_stash_like "$@"
563 git checkout -b $branch $REV^ &&
564 apply_stash "$@" && {
565 test -z "$IS_STASH_REF" || drop_stash "$@"
569 PARSE_CACHE='--not-parsed'
570 # The default command is "save" if nothing but options are given
576 *) seen_non_option=t; break ;;
580 test -n "$seen_non_option" || set "save" "$@"
606 create_stash "$*" && echo "$w_commit"
628 say "$(gettext "(To restore them type \"git stash apply\")")"